Unique Set Cover on Unit Disks and Unit Squares
Abstract
We study the Unique Set Cover problem on unit disks and unit squares. For a given set of points and a set of geometric objects both in the plane, the objective of the Unique Set Cover problem is to select a subset of objects such that every point in is covered by at least one object in and the number of points covered uniquely is maximized, where a point is covered uniquely if the point is covered by exactly one object in . In this paper, (i) we show that the Unique Set Cover is NP-hard on both unit disks and unit squares, and (ii) we give a PTAS for this problem on unit squares by applying the mod-one approach of Chan and Hu (Comput. Geom. 48(5), 2015).
1 Introduction
Consider a set of points and a set of geometric objects both in the plane. For a subset of objects, we say that a point is covered uniquely by if there is exactly one object in that covers . In the Unique Set Cover problem, the objective is to compute a subset of objects so as to cover all points in and to maximize the number of points covered uniquely by .
There is a slightly different problem, called Unique Cover, where the input is the same as the Unique Set Cover problem and the objective is to compute a subset that maximizes the number of points covered uniquely; note that not all the points in are required to be covered in an instance of the Unique Cover problem. Both Unique Set Cover and Unique Cover belong to the larger class of the Unit Cover problem in which we are given the same input and the objective is to compute a minimum-cardinality subset so as to cover all points in . Indeed, Unique Set Cover combines the objectives of the Unique Cover and Unit Cover problems.
In this paper, we are interested in the Unique Set Cover problem on unit disks and unit squares. Formally, given a set of points and a set of unit disks (resp., unit squares) both in the plane, the objective of the Unique Disk (resp., Square) Set Cover problem is to find a subset that covers all points in and that maximizes the number of points covered uniquely. Figure 1 shows an instance of, e.g., the Unique Disk Set Cover problem and an optimal solution for this instance.
The Unique Cover problem was first studied by Erlebach and van Leeuwen [5] on unit disks and is motivated by its applications in wireless communication networks, where the broadcasting range of equivalent base stations have been frequently modelled as unit disks. Providers of wireless networks often consider having a number of base stations to service their customers. However, if a customer receives signals from too many base stations, then the customer may receive no service at all due to the resulting interference. As such, each customer is ideally serviced by exactly one base station and we want such a service to be provided to as many customers as possible. Our motivation for studying the Unique Set Cover problem is that what if in addition to providing service to as many customers as possible by exactly one base station, we still want to do service all the customers as well.
Related Work.
The Unit Cover problem is a well-known NP-hard problem on unit disks and unit squares. Mustafa and Ray [11] gave the first PTAS for the Unit Cover problem on both unit disks and unit squares using a local search technique. This technique was also discovered independently by Chan and Har-Peled [1] who gave the first PTAS for the maximum independent set problem on pseudo-disks in the plane. Demaine et al. [3] introduced the non-geometric variant of the Unique Cover problem and gave a polynomial-time -approximation algorithm for the problem, where is the number of elements of the universe in the corresponding set system. Erlebach and van Leeuwen [5], who were first to study the geometric version of the Unique Cover problem, showed that Unique Cover problem is NP-hard on both unit disks and unit squares (see also [12]).
By combining dynamic programming and the shifting strategy of Hochbaum and Maass [7], Erlebach and van Leeuwen [6] gave the first PTAS for the weighted version of the Unit Cover problem on unit squares, where each unit square in is associated with a positive value as weight and the objective is to cover the points in so as to minimize the total weight of the unit squares selected.111The local search technique of Mustafa and Ray [11] does not apply to the weighted version of these problems. This approach was also used by Ito et al. [9] who gave a PTAS for the Unique Cover problem on unit squares. However, this technique does not seem to work for unit disks. In fact, Ito et al. [8] used this approach to give a polynomial-time approximation algorithm for the Unique Cover problem on unit disks with approximation factor , where is any fixed constant. Moreover, this approach involves sophisticated dynamic programming. Finally, by introducing a mod-one transformation, Chan and Hu [2] gave a PTAS for the Red-Blue Unit-Square Cover problem, which is defined as follows: given a red point set , a blue point set and a set of unit squares in the plane, the objective is to select a subset of the unit squares so as to cover all the blue points while minimizing the number of red points covered.
Our Results.
In this paper, we first show that both Unique Disk Set Cover and Unique Square Set Cover are NP-hard. We note that the Unique Cover problem is shown to be NP-hard on unit disks and unit squares [5]. However, their hardness, which is based on a reduction from the Independent Set problem on planar graphs of maximum degree 3, does not apply to proving the hardness of the Unique Set Cover problem mainly because all points in are required to be covered in an instance of the Unique Set Cover problem. We instead show a reduction from a variant of the planar 3SAT problem to prove the NP-hardness of Unique Set Cover on both unit disks and unit squares.
As our second result, we show that the mod-one approach of Chan and Hu [2] provides a PTAS for the Unique Square Set Cover problem. The only difference is that instead of storing 4-tuples of unit squares when solving the dynamic programming, we store 6-tuples of unit squares and show that they suffice to capture the necessary information (we will discuss this approach in more details in Section 3). See Table 1 for a summary of previous and new results.
We first prove the NP-hardness of the problems in Section LABEL:sec:npHardness and will then give a PTAS for the problem on unit squares in Section 3. Finally, we conclude the paper with a discussion on open problems in Section 4.
Problem | Unit Squares | Unit Disks |
---|---|---|
Unit Cover | NP-hard, PTAS [11] | NP-hard, PTAS [11] |
Unique Cover | NP-hard [5], PTAS [9] | NP-hard [5], 4.31-approximation [8] |
Unique Set Cover | NP-hard [Theorem 2.1] | NP-hard [Theorem 2.2] |
PTAS [Theorem 3.2] |
2 Hardness
In this section, we first show that the Unique Disk Set Cover is NP-hard; the NP-hardness of the Unique Square Set Cover is proved analogously and we will discuss it at the end of this section.
Unique Disk Set Cover
Input. A set of points, a set of unit disks, and an integer .
Output. Does there exist a set that covers all points in and that covers at least points uniquely?
To prove the hardness of the Unique Disk Set Cover, we show a reduction from the Planar Variable Restricted 3SAT (Planar VR3SAT, for short) problem. Planar VR3SAT is a constrained version of 3SAT in which each variable can appear in at most three clauses and the corresponding variable-clause graph is planar. Efrat et al. [4] showed that Planar VR3SAT is NP-hard. Let be an instance of Planar VR3SAT with clauses and variables ; we denote the two literals of a variable by and . We construct an instance of the Unique Disk Set Cover problem such that has a solution with at least points covered unqiuely, for some that we will determine its value later, if and only if is satisfiable. Given , we first construct the variable-clause graph of in the non-crossing comb-shape form of Knuth and Raghunathan [10]. Without loss of generality, we assume that the variable vertices lie on a vertical line and the clause vertices are connected from left or right of that line; see Figure 2 for an illustration. Note that each variable appears in at most three clauses.
Gadgets.
For each variable , we replace the corresponding variable vertex in with a single unit disk containing three groups of points each of which consists of points (where is the number of clauses in ). We call each such groups of points a cloud. If a literal of appears in a clause, then the variable gadget of is connected to the corresponding clause gadget by a chain of unit disks such that (i) the first unit disk in the chain covers exactly one of the clouds in the variable unit disk, and (ii) every two consecutive unit disks in the chain share a cloud. We call such a chain of unit disks a wire; see Figure 3(Right) for an illustration. A cloud shared between two unit disks in a wire has also points. We call the unit disk of a wire that shares a cloud with the variable unit disk a start disk. For the clause gadget, where three wires meet, we make the last three unit disks (each of which arriving from one of the wires) to have a non-empty intersection region in which we insert one single point; see Figure 3(Left). We call this point a clause point.
Consider the cloud shared between a variable unit disk and a start disk. If all the clouds in the corresponding wire are covered uniquely, then exactly one of the variable unit disk and the start disk must be selected to cover the cloud shared between them. Consequently, depending on whether the variable unit disk is selected, we can decide whether the clause point of the clause gadget on the other end of the wire is covered by the last unit disk of this wire. That is, we can create two ways of covering the clouds of the wire uniquely, one of which will not be able to cover the corresponding clause point. It is clear from the variable unit disk shown in Figure 3 that if the variable unit disk is selected (resp., is not selected), then the clause point is covered (resp., is not covered) by the last unit disk of the corresponding wire. We remark that this is always doable, even for the wires that require one bend, by adjusting the number of unit disks in the wire. See the top wire shown in Figure 4 for an example. We set a variable to true or false depending on whether its corresponding variable unit disk is selected or not to cover the clouds that it contains.
Finally, we need a gadget for negation literals. Suppose that the literal appears in a clause, for some variable in . To indicate the negation literal, we add two additional unit disks besides the wire connecting the variable unit disk to the corresponding clause gadget; see the two (falling and green) shaded unit disks in the middle wire (i.e., the wire corresponding to ) shown in Figure 4. We call these two newly-added unit disks the negation pair. Observe that the negation pair share a cloud and each of them covers one of the previously existed clouds in the current wire. The construction of the negation pair ensures that if the variable unit disk is selected (resp., is not selected), i.e., it is set to true (resp., false), then the clause point is not covered (resp., is covered). The same gadget can be used for the negation literals whose corresponding wires have a bend; see for instance the lowest wire shown in Figure 4.
Construction Details.
Clearly, our construction allows the wires to be connected to a variable unit disk from both left and right of the variable unit disk; we just need to move the corresponding clouds inside the variable unit disk accordingly. By scaling and making the drawing of the wires consistent with the edges of , we can ensure that the unit disks of different wires will never intersect. Note that we can have the scaling so as to increase the number of unit disks in any wire by only a constant factor. Hence, by this and from the construction, we have that the number of disks in the instance is polynomial in terms of and . To see the value of , the number of points in , we set to the number of clouds used in our construction. Since each cloud contains points, the total number of points in is as we also have clause points. Therefore, the total complexity of the constructed instance is polynomial in and . Moreover, it is not hard to see that can be constructed in polynomial time. We now show the following result.
Lemma 2.1.
There exists a feasible solution for that covers at least points uniquely if and only if is satisfiable.
Proof.
Let be a feasible solution for that covers at least points. First, by the choice of and the fact that we have exactly clause points and any other point belongs to some cloud, we conclude that all the clouds in must be covered uniquely by . For each variable , where , we set the variable to true if its corresponding unit disk is in ; otherwise, we set to false. To show that this results in a truth assignment, suppose for a contradiction that there exists a clause that is not satisfied by this assignment. Take any variable . If (resp., ), then the variable is set to false (resp., true) by the assignment and so the variable unit disk corresponding to is not in (resp., is in ). Consequently, it follows from the construction that the point clause of is not covered by the wire arriving from . This means that none of the wires arriving at will cover its point clause — this is a contradiction to the feasibility of .
Given a truth assignment for , we construct a feasible solution for covering at least points uniquely as follows. For each variable in , where : if is set to true, then we add the corresponding variable unit disk into ; otherwise, we add the start disks intersecting this variable unit disk into . Consequently, every other unit disks of the corresponding wires are added into in such a way that each cloud is covered uniquely by one of the unit disks along the wire. Clearly, all clouds are covered by . Moreover, also covers all the clause points because the only way to have a clause satisfied is to have at least one of the wires arriving at covering the clause point of . Finally, by adding every other unit disk of each wire into , we ensure that all the clouds are covered uniquely by . Since we have clouds each of which consists of points, we conclude that is a feasible solution that covers at least points in uniquely. ∎
By Lemma 2.1, we have the following theorem.
Theorem 2.1.
The Unique Disk Set Cover is NP-hard.
NP-Hardness for Unit Squares.
The proof for the NP-hardness of the Unique Square Set Cover problem is almost identical to the one shown above for unit disks. In what follows, we mainly describe the gadgets for unit squares so as then one can verify that the hardness follows.
Starting by the comb-shape form of Knuth and Raghunathan [10] for an instance of the Planar VR3SAT problem, we replace each variable vertex with a unit square and will then have three (unit-square type) wires connecting the variable unit square to the corresponding clause gadgets. This is again doable even if we have one bend along the wire; see Figure 5 for an illustration. Moreover, we can make the three wires arriving at a clause to have a non-empty intersection region in which we insert our single clause point. Finally, the negation pair is constructed in an analogous way. See Figure 5. Note that more unit squares are used (than unit disks) in a wire connecting a variable unit square to its corresponding clauses. However, we can still ensure to have the scaling step to have a polynomial number of unit squares in each wire.
One can verify that the construction is again polynomial in and , and we can prove a lemma similar to Lemma 2.1 for this new construction. So, we have the following result.
Theorem 2.2.
The Unique Square Set Cover is NP-hard.
3 PTAS
In this section, we give a PTAS for the Unique Square Set Cover problem by applying the mod-one approach of Chan and Hu [2]; we first describe this approach.
Recall the dynamic programming involed in the PTASes developed by Ito et al. [9], and Erlebach and van Leeuwen [6]. The dynamic program is essentially based on the line-sweep paradigm by considering points and squares from left to right, and extending the uniquely covered region sequentially. However, adding one square can influence squares that were already chosen and so we need to keep track of the squares that are possibly influenced by a newly-added square. The complication stems mainly from the fact that a new square may influence too many squares. This requires keeping track of the changes on the two separate chains induced by the boundary of the current squares. The mod-one approach avoids this complication by transforming these chains into two chains that are connected at the corner points.
For a set of unit squares containing a common point, where are arranged in increasing -order of their centres, the set is called a monotone set if the centres of are in increasing or decreasing -order. The boundary of the union of the squares in a monotone set consists of two monotone chains, called complementary chains. In the mod-one transformation, a point in the plane is mapped to the point , where denotes the fractional part of the real number . Applying the mod-one to a monotone set transforms the squares in such a way that the two complementary chains are mapped to two monotone chains that are connected at the corner points. See Figure 6 for an illustration.
We now show that the mod-one approach provides a PTAS for the Unique Square Set Cover problem. The plan is to first give an exact dynamic programming algorithm for a special variant of the problem, where the points in are all inside a square for some constant , and then to apply the shifting strategy of Hochbaum and Maass [7] to obtain our PTAS. Note that this follows the framework of [2] with the only difference that we store 6-tuples of unit squares, instead of storing 4-tuples, when solving the dynamic programming.
Lemma 3.1.
Let denote an optimal solution for an instance of the Unique Square Set Cover problem in which the set is inside a square, for some constant . Then, can be decomposed into monotone sets.
Proof.
This lemma is essentially proved in [2], but for a different problem. The idea is to draw a unit side-length grid over the square and then show that each unit square appears in the boundary of the union of unit square containing a fixed grid point . By dividing the plane into four quadrants at and grouping the unit squares containing based on their contribution to the part of the union boundary in quadrants, is decomposed into monotone sets. ∎
We now give an exact dynamic programming algorithm for the variant of the Unique Square Set Cover problem, where all points of are inside a square for some constant .
Theorem 3.1.
For any instance of Unique Square Set Cover problem in which the set is inside a square for a constant , the optimal solution can be computed in time.
Proof.
We describe the dynamic programming algorithm by a state-transition diagram. We store 6-tuples of unit squares in each state. More specifically, a state is defined to consist of (i) a vertical sweep line that passes through a corner of an input square, after taking mod 1, and (ii) 6-tuples of unit squares of the form given that , , , , , and are in the increasing order of -coordinate, they form a monotone set, and lies between the corners of and .
Observe that each 6-tuple corresponds to a monotone set : and represent the start and end squares of and and represent the squares of the two complementary chains of , after taking mod 1, that are intersected by the sweep line . Moreover, we define and as the predecessor of and the successor of , respectively. We now define a transition between two states and its cost function. Given a state , we create a transition from to a new state as follows. Let be the 6-tuple such that the corner point of has the smallest -coordinate mod 1. First, the new sweep line is located at the corner of . Next, we replace this 6-tuple by a new 6-tuple , where is a unit square that satisfies the conditions of a state. is now set to this new state with having all other 6-tuples left unchanged. To see the cost of this transition, let (resp., ) be the number of points in that lie between and , after taking mod 1, and are not covered (resp., are covered uniquely) by the squares from the 6-tuples of unit squares, before taking mod 1. If , then we remove this transition from the diagram (since all points must be covered). Otherwise, we set the cost of this transition to .
The problem is then reduced to finding the longest path in this state-transition diagram for which we can appropriately add the start and end states. Since the diagram is a directed acyclic graph, we can construct the diagram and find the longest path in time. ∎
We can now apply the shifting strategy of Hochbaum and Maass [7] to obtain our PTAS. The proof of the following theorem is much similar to the one given in [2] and so we omit it here.
Theorem 3.2.
For any fixed constant , there exists a polynomial time -approximation algorithm for the Unique Square Set Cover problem.
4 Conclusion
In this paper, we showed that the Unique Disk Set Cover and Unique Square Set Cover problems are both NP-hard and gave a PTAS for the Unique Square Set Cover problem. Our PTAS is based on the mod-one transformation of Chan and Hu [2], which does not apply to unit disks. Therefore, giving a PTAS for the Unique Disk Set Cover remains open.
References
- [1] Timothy M. Chan and Sariel Har-Peled. Approximation algorithms for maximum independent set of pseudo-disks. Discrete & Computational Geometry, 48(2):373–392, 2012.
- [2] Timothy M. Chan and Nan Hu. Geometric red-blue set cover for unit squares and related problems. Comput. Geom., 48(5):380–385, 2015.
- [3] Erik D. Demaine, Uriel Feige, MohammadTaghi Hajiaghayi, and Mohammad R. Salavatipour. Combination can be hard: Approximability of the unique coverage problem. SIAM J. Comput., 38(4):1464–1483, 2008.
- [4] Alon Efrat, Cesim Erten, and Stephen G. Kobourov. Fixed-location circular arc drawing of planar graphs. J. Graph Algorithms Appl., 11(1):145–164, 2007.
- [5] Thomas Erlebach and Erik Jan van Leeuwen. Approximating geometric coverage problems. In Proceedings of the Nineteenth Annual ACM-SIAM Symposium on Discrete Algorithms, SODA 2008, San Francisco, California, USA, January 20-22, 2008, pages 1267–1276, 2008.
- [6] Thomas Erlebach and Erik Jan van Leeuwen. PTAS for weighted set cover on unit squares. In Approximation, Randomization, and Combinatorial Optimization. Algorithms and Techniques, 13th International Workshop, APPROX 2010, and 14th International Workshop, RANDOM 2010, Barcelona, Spain, September 1-3, 2010. Proceedings, pages 166–177, 2010.
- [7] Dorit S. Hochbaum and Wolfgang Maass. Approximation schemes for covering and packing problems in image processing and VLSI. J. ACM, 32(1):130–136, 1985.
- [8] Takehiro Ito, Shin-Ichi Nakano, Yoshio Okamoto, Yota Otachi, Ryuhei Uehara, Takeaki Uno, and Yushi Uno. A 4.31-approximation for the geometric unique coverage problem on unit disks. Theor. Comput. Sci., 544:14–31, 2014.
- [9] Takehiro Ito, Shin-Ichi Nakano, Yoshio Okamoto, Yota Otachi, Ryuhei Uehara, Takeaki Uno, and Yushi Uno. A polynomial-time approximation scheme for the geometric unique coverage problem on unit squares. Comput. Geom., 51:25–39, 2016.
- [10] Donald E. Knuth and Arvind Raghunathan. The problem of compatible representatives. SIAM J. Discrete Math., 5(3):422–427, 1992.
- [11] Nabil H. Mustafa and Saurabh Ray. Improved results on geometric hitting set problems. Discrete & Computational Geometry, 44(4):883–895, 2010.
- [12] Erik J. van Leeuwen. Optimization and Approximation on Systems on Geometric Objects. PhD thesis, University of Amsterdam, Amsterdam, Netherlands, 2009.